// automatically generated by the FlatBuffers compiler, do not modify


#ifndef FLATBUFFERS_GENERATED_SEGMENT_VAST_FBS_H_
#define FLATBUFFERS_GENERATED_SEGMENT_VAST_FBS_H_

#include "flatbuffers/flatbuffers.h"

#include "table_slice.hpp"
#include "uuid.hpp"

namespace vast {
namespace fbs {
namespace interval {

struct v0;

}  // namespace interval

namespace segment {

struct v0;
struct v0Builder;

}  // namespace segment

struct Segment;
struct SegmentBuilder;

namespace segment {

enum class Segment : uint8_t {
  NONE = 0,
  v0 = 1,
  MIN = NONE,
  MAX = v0
};

inline const Segment (&EnumValuesSegment())[2] {
  static const Segment values[] = {
    Segment::NONE,
    Segment::v0
  };
  return values;
}

inline const char * const *EnumNamesSegment() {
  static const char * const names[3] = {
    "NONE",
    "v0",
    nullptr
  };
  return names;
}

inline const char *EnumNameSegment(Segment e) {
  if (flatbuffers::IsOutRange(e, Segment::NONE, Segment::v0)) return "";
  const size_t index = static_cast<size_t>(e);
  return EnumNamesSegment()[index];
}

template<typename T> struct SegmentTraits {
  static const Segment enum_value = Segment::NONE;
};

template<> struct SegmentTraits<vast::fbs::segment::v0> {
  static const Segment enum_value = Segment::v0;
};

bool VerifySegment(flatbuffers::Verifier &verifier, const void *obj, Segment type);
bool VerifySegmentVector(flatbuffers::Verifier &verifier, const flatbuffers::Vector<flatbuffers::Offset<void>> *values, const flatbuffers::Vector<uint8_t> *types);

}  // namespace segment

namespace interval {

/// A half-open interval *[a,b)* in the ID Space.
FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(8) v0 FLATBUFFERS_FINAL_CLASS {
 private:
  uint64_t begin_;
  uint64_t end_;

 public:
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.interval.v0";
  }
  v0()
      : begin_(0),
        end_(0) {
  }
  v0(uint64_t _begin, uint64_t _end)
      : begin_(flatbuffers::EndianScalar(_begin)),
        end_(flatbuffers::EndianScalar(_end)) {
  }
  /// The left side of the interval (inclusive).
  uint64_t begin() const {
    return flatbuffers::EndianScalar(begin_);
  }
  /// The right side of the interval (exclusive).
  uint64_t end() const {
    return flatbuffers::EndianScalar(end_);
  }
};
FLATBUFFERS_STRUCT_END(v0, 16);

}  // namespace interval

namespace segment {

/// A bundled sequence of table slices.
struct v0 FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef v0Builder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.segment.v0";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_SLICES = 4,
    VT_UUID = 6,
    VT_IDS = 8,
    VT_EVENTS = 10
  };
  /// The contained table slices.
  const flatbuffers::Vector<flatbuffers::Offset<vast::fbs::FlatTableSlice>> *slices() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<vast::fbs::FlatTableSlice>> *>(VT_SLICES);
  }
  /// A unique identifier.
  const vast::fbs::uuid::v0 *uuid() const {
    return GetPointer<const vast::fbs::uuid::v0 *>(VT_UUID);
  }
  /// The ID intervals this segment covers.
  const flatbuffers::Vector<const vast::fbs::interval::v0 *> *ids() const {
    return GetPointer<const flatbuffers::Vector<const vast::fbs::interval::v0 *> *>(VT_IDS);
  }
  /// The number of events in the store.
  uint64_t events() const {
    return GetField<uint64_t>(VT_EVENTS, 0);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_SLICES) &&
           verifier.VerifyVector(slices()) &&
           verifier.VerifyVectorOfTables(slices()) &&
           VerifyOffset(verifier, VT_UUID) &&
           verifier.VerifyTable(uuid()) &&
           VerifyOffset(verifier, VT_IDS) &&
           verifier.VerifyVector(ids()) &&
           VerifyField<uint64_t>(verifier, VT_EVENTS) &&
           verifier.EndTable();
  }
};

struct v0Builder {
  typedef v0 Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_slices(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<vast::fbs::FlatTableSlice>>> slices) {
    fbb_.AddOffset(v0::VT_SLICES, slices);
  }
  void add_uuid(flatbuffers::Offset<vast::fbs::uuid::v0> uuid) {
    fbb_.AddOffset(v0::VT_UUID, uuid);
  }
  void add_ids(flatbuffers::Offset<flatbuffers::Vector<const vast::fbs::interval::v0 *>> ids) {
    fbb_.AddOffset(v0::VT_IDS, ids);
  }
  void add_events(uint64_t events) {
    fbb_.AddElement<uint64_t>(v0::VT_EVENTS, events, 0);
  }
  explicit v0Builder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  flatbuffers::Offset<v0> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<v0>(end);
    return o;
  }
};

inline flatbuffers::Offset<v0> Createv0(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<vast::fbs::FlatTableSlice>>> slices = 0,
    flatbuffers::Offset<vast::fbs::uuid::v0> uuid = 0,
    flatbuffers::Offset<flatbuffers::Vector<const vast::fbs::interval::v0 *>> ids = 0,
    uint64_t events = 0) {
  v0Builder builder_(_fbb);
  builder_.add_events(events);
  builder_.add_ids(ids);
  builder_.add_uuid(uuid);
  builder_.add_slices(slices);
  return builder_.Finish();
}

inline flatbuffers::Offset<v0> Createv0Direct(
    flatbuffers::FlatBufferBuilder &_fbb,
    const std::vector<flatbuffers::Offset<vast::fbs::FlatTableSlice>> *slices = nullptr,
    flatbuffers::Offset<vast::fbs::uuid::v0> uuid = 0,
    const std::vector<vast::fbs::interval::v0> *ids = nullptr,
    uint64_t events = 0) {
  auto slices__ = slices ? _fbb.CreateVector<flatbuffers::Offset<vast::fbs::FlatTableSlice>>(*slices) : 0;
  auto ids__ = ids ? _fbb.CreateVectorOfStructs<vast::fbs::interval::v0>(*ids) : 0;
  return vast::fbs::segment::Createv0(
      _fbb,
      slices__,
      uuid,
      ids__,
      events);
}

}  // namespace segment

struct Segment FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef SegmentBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.Segment";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_SEGMENT_TYPE = 4,
    VT_SEGMENT = 6
  };
  vast::fbs::segment::Segment segment_type() const {
    return static_cast<vast::fbs::segment::Segment>(GetField<uint8_t>(VT_SEGMENT_TYPE, 0));
  }
  const void *segment() const {
    return GetPointer<const void *>(VT_SEGMENT);
  }
  template<typename T> const T *segment_as() const;
  const vast::fbs::segment::v0 *segment_as_v0() const {
    return segment_type() == vast::fbs::segment::Segment::v0 ? static_cast<const vast::fbs::segment::v0 *>(segment()) : nullptr;
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyField<uint8_t>(verifier, VT_SEGMENT_TYPE) &&
           VerifyOffset(verifier, VT_SEGMENT) &&
           VerifySegment(verifier, segment(), segment_type()) &&
           verifier.EndTable();
  }
};

template<> inline const vast::fbs::segment::v0 *Segment::segment_as<vast::fbs::segment::v0>() const {
  return segment_as_v0();
}

struct SegmentBuilder {
  typedef Segment Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_segment_type(vast::fbs::segment::Segment segment_type) {
    fbb_.AddElement<uint8_t>(Segment::VT_SEGMENT_TYPE, static_cast<uint8_t>(segment_type), 0);
  }
  void add_segment(flatbuffers::Offset<void> segment) {
    fbb_.AddOffset(Segment::VT_SEGMENT, segment);
  }
  explicit SegmentBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  flatbuffers::Offset<Segment> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<Segment>(end);
    return o;
  }
};

inline flatbuffers::Offset<Segment> CreateSegment(
    flatbuffers::FlatBufferBuilder &_fbb,
    vast::fbs::segment::Segment segment_type = vast::fbs::segment::Segment::NONE,
    flatbuffers::Offset<void> segment = 0) {
  SegmentBuilder builder_(_fbb);
  builder_.add_segment(segment);
  builder_.add_segment_type(segment_type);
  return builder_.Finish();
}

namespace segment {

}  // namespace segment

namespace segment {

inline bool VerifySegment(flatbuffers::Verifier &verifier, const void *obj, Segment type) {
  switch (type) {
    case Segment::NONE: {
      return true;
    }
    case Segment::v0: {
      auto ptr = reinterpret_cast<const vast::fbs::segment::v0 *>(obj);
      return verifier.VerifyTable(ptr);
    }
    default: return true;
  }
}

inline bool VerifySegmentVector(flatbuffers::Verifier &verifier, const flatbuffers::Vector<flatbuffers::Offset<void>> *values, const flatbuffers::Vector<uint8_t> *types) {
  if (!values || !types) return !values && !types;
  if (values->size() != types->size()) return false;
  for (flatbuffers::uoffset_t i = 0; i < values->size(); ++i) {
    if (!VerifySegment(
        verifier,  values->Get(i), types->GetEnum<Segment>(i))) {
      return false;
    }
  }
  return true;
}

}  // namespace segment

inline const vast::fbs::Segment *GetSegment(const void *buf) {
  return flatbuffers::GetRoot<vast::fbs::Segment>(buf);
}

inline const vast::fbs::Segment *GetSizePrefixedSegment(const void *buf) {
  return flatbuffers::GetSizePrefixedRoot<vast::fbs::Segment>(buf);
}

inline const char *SegmentIdentifier() {
  return "vSEG";
}

inline bool SegmentBufferHasIdentifier(const void *buf) {
  return flatbuffers::BufferHasIdentifier(
      buf, SegmentIdentifier());
}

inline bool VerifySegmentBuffer(
    flatbuffers::Verifier &verifier) {
  return verifier.VerifyBuffer<vast::fbs::Segment>(SegmentIdentifier());
}

inline bool VerifySizePrefixedSegmentBuffer(
    flatbuffers::Verifier &verifier) {
  return verifier.VerifySizePrefixedBuffer<vast::fbs::Segment>(SegmentIdentifier());
}

inline void FinishSegmentBuffer(
    flatbuffers::FlatBufferBuilder &fbb,
    flatbuffers::Offset<vast::fbs::Segment> root) {
  fbb.Finish(root, SegmentIdentifier());
}

inline void FinishSizePrefixedSegmentBuffer(
    flatbuffers::FlatBufferBuilder &fbb,
    flatbuffers::Offset<vast::fbs::Segment> root) {
  fbb.FinishSizePrefixed(root, SegmentIdentifier());
}

}  // namespace fbs
}  // namespace vast

#endif  // FLATBUFFERS_GENERATED_SEGMENT_VAST_FBS_H_
