// automatically generated by the FlatBuffers compiler, do not modify


#ifndef FLATBUFFERS_GENERATED_TABLESLICE_VAST_FBS_H_
#define FLATBUFFERS_GENERATED_TABLESLICE_VAST_FBS_H_

#include "flatbuffers/flatbuffers.h"

namespace vast {
namespace fbs {
namespace table_slice {
namespace arrow {

struct v0;
struct v0Builder;

}  // namespace arrow

namespace msgpack {

struct v0;
struct v0Builder;

}  // namespace msgpack
}  // namespace table_slice

struct TableSlice;
struct TableSliceBuilder;

struct FlatTableSlice;
struct FlatTableSliceBuilder;

namespace table_slice {

/// The union of all possible table slice encoding and version combinations.
enum class TableSlice : uint8_t {
  NONE = 0,
  arrow_v0 = 1,
  msgpack_v0 = 2,
  MIN = NONE,
  MAX = msgpack_v0
};

inline const TableSlice (&EnumValuesTableSlice())[3] {
  static const TableSlice values[] = {
    TableSlice::NONE,
    TableSlice::arrow_v0,
    TableSlice::msgpack_v0
  };
  return values;
}

inline const char * const *EnumNamesTableSlice() {
  static const char * const names[4] = {
    "NONE",
    "arrow_v0",
    "msgpack_v0",
    nullptr
  };
  return names;
}

inline const char *EnumNameTableSlice(TableSlice e) {
  if (flatbuffers::IsOutRange(e, TableSlice::NONE, TableSlice::msgpack_v0)) return "";
  const size_t index = static_cast<size_t>(e);
  return EnumNamesTableSlice()[index];
}

template<typename T> struct TableSliceTraits {
  static const TableSlice enum_value = TableSlice::NONE;
};

template<> struct TableSliceTraits<vast::fbs::table_slice::arrow::v0> {
  static const TableSlice enum_value = TableSlice::arrow_v0;
};

template<> struct TableSliceTraits<vast::fbs::table_slice::msgpack::v0> {
  static const TableSlice enum_value = TableSlice::msgpack_v0;
};

bool VerifyTableSlice(flatbuffers::Verifier &verifier, const void *obj, TableSlice type);
bool VerifyTableSliceVector(flatbuffers::Verifier &verifier, const flatbuffers::Vector<flatbuffers::Offset<void>> *values, const flatbuffers::Vector<uint8_t> *types);

namespace arrow {

/// A table slice encoded with Apache Arrow.
struct v0 FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef v0Builder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.table_slice.arrow.v0";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_LAYOUT = 4,
    VT_SCHEMA = 6,
    VT_RECORD_BATCH = 8
  };
  /// The schema of the data.
  /// TODO: The schema is already included in the record batch, but it cannot be
  /// mapped 1-to-1 to VAST types. This can be resolved by using extension types
  /// for Arrow. Additionally, this is currently CAF binary; make this a
  /// separarate table.
  const flatbuffers::Vector<uint8_t> *layout() const {
    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_LAYOUT);
  }
  /// The Arrow Schema containing the Record Batch layout.
  const flatbuffers::Vector<uint8_t> *schema() const {
    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_SCHEMA);
  }
  /// The Arrow Recod Batch containing all data.
  const flatbuffers::Vector<uint8_t> *record_batch() const {
    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_RECORD_BATCH);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_LAYOUT) &&
           verifier.VerifyVector(layout()) &&
           VerifyOffset(verifier, VT_SCHEMA) &&
           verifier.VerifyVector(schema()) &&
           VerifyOffset(verifier, VT_RECORD_BATCH) &&
           verifier.VerifyVector(record_batch()) &&
           verifier.EndTable();
  }
};

struct v0Builder {
  typedef v0 Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_layout(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> layout) {
    fbb_.AddOffset(v0::VT_LAYOUT, layout);
  }
  void add_schema(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> schema) {
    fbb_.AddOffset(v0::VT_SCHEMA, schema);
  }
  void add_record_batch(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> record_batch) {
    fbb_.AddOffset(v0::VT_RECORD_BATCH, record_batch);
  }
  explicit v0Builder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  flatbuffers::Offset<v0> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<v0>(end);
    return o;
  }
};

inline flatbuffers::Offset<v0> Createv0(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> layout = 0,
    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> schema = 0,
    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> record_batch = 0) {
  v0Builder builder_(_fbb);
  builder_.add_record_batch(record_batch);
  builder_.add_schema(schema);
  builder_.add_layout(layout);
  return builder_.Finish();
}

inline flatbuffers::Offset<v0> Createv0Direct(
    flatbuffers::FlatBufferBuilder &_fbb,
    const std::vector<uint8_t> *layout = nullptr,
    const std::vector<uint8_t> *schema = nullptr,
    const std::vector<uint8_t> *record_batch = nullptr) {
  auto layout__ = layout ? _fbb.CreateVector<uint8_t>(*layout) : 0;
  auto schema__ = schema ? _fbb.CreateVector<uint8_t>(*schema) : 0;
  auto record_batch__ = record_batch ? _fbb.CreateVector<uint8_t>(*record_batch) : 0;
  return vast::fbs::table_slice::arrow::Createv0(
      _fbb,
      layout__,
      schema__,
      record_batch__);
}

}  // namespace arrow

namespace msgpack {

/// A table slice encoded with MessagePack.
struct v0 FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef v0Builder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.table_slice.msgpack.v0";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_LAYOUT = 4,
    VT_OFFSET_TABLE = 6,
    VT_DATA = 8
  };
  /// The schema of the data.
  /// TODO: currently CAF binary; make this a separate table.
  const flatbuffers::Vector<uint8_t> *layout() const {
    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_LAYOUT);
  }
  /// Offsets from the beginning of the buffer to each row.
  const flatbuffers::Vector<uint64_t> *offset_table() const {
    return GetPointer<const flatbuffers::Vector<uint64_t> *>(VT_OFFSET_TABLE);
  }
  /// The buffer that contains the MessagePack data.
  const flatbuffers::Vector<uint8_t> *data() const {
    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_DATA);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_LAYOUT) &&
           verifier.VerifyVector(layout()) &&
           VerifyOffset(verifier, VT_OFFSET_TABLE) &&
           verifier.VerifyVector(offset_table()) &&
           VerifyOffset(verifier, VT_DATA) &&
           verifier.VerifyVector(data()) &&
           verifier.EndTable();
  }
};

struct v0Builder {
  typedef v0 Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_layout(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> layout) {
    fbb_.AddOffset(v0::VT_LAYOUT, layout);
  }
  void add_offset_table(flatbuffers::Offset<flatbuffers::Vector<uint64_t>> offset_table) {
    fbb_.AddOffset(v0::VT_OFFSET_TABLE, offset_table);
  }
  void add_data(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> data) {
    fbb_.AddOffset(v0::VT_DATA, data);
  }
  explicit v0Builder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  flatbuffers::Offset<v0> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<v0>(end);
    return o;
  }
};

inline flatbuffers::Offset<v0> Createv0(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> layout = 0,
    flatbuffers::Offset<flatbuffers::Vector<uint64_t>> offset_table = 0,
    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> data = 0) {
  v0Builder builder_(_fbb);
  builder_.add_data(data);
  builder_.add_offset_table(offset_table);
  builder_.add_layout(layout);
  return builder_.Finish();
}

inline flatbuffers::Offset<v0> Createv0Direct(
    flatbuffers::FlatBufferBuilder &_fbb,
    const std::vector<uint8_t> *layout = nullptr,
    const std::vector<uint64_t> *offset_table = nullptr,
    const std::vector<uint8_t> *data = nullptr) {
  auto layout__ = layout ? _fbb.CreateVector<uint8_t>(*layout) : 0;
  auto offset_table__ = offset_table ? _fbb.CreateVector<uint64_t>(*offset_table) : 0;
  auto data__ = data ? _fbb.CreateVector<uint8_t>(*data) : 0;
  return vast::fbs::table_slice::msgpack::Createv0(
      _fbb,
      layout__,
      offset_table__,
      data__);
}

}  // namespace msgpack
}  // namespace table_slice

/// A horizontal partition of a table. A slice defines a tabular interface for
/// accessing homogenous data independent of the concrete carrier format.
struct TableSlice FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef TableSliceBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.TableSlice";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_TABLE_SLICE_TYPE = 4,
    VT_TABLE_SLICE = 6
  };
  vast::fbs::table_slice::TableSlice table_slice_type() const {
    return static_cast<vast::fbs::table_slice::TableSlice>(GetField<uint8_t>(VT_TABLE_SLICE_TYPE, 0));
  }
  const void *table_slice() const {
    return GetPointer<const void *>(VT_TABLE_SLICE);
  }
  template<typename T> const T *table_slice_as() const;
  const vast::fbs::table_slice::arrow::v0 *table_slice_as_arrow_v0() const {
    return table_slice_type() == vast::fbs::table_slice::TableSlice::arrow_v0 ? static_cast<const vast::fbs::table_slice::arrow::v0 *>(table_slice()) : nullptr;
  }
  const vast::fbs::table_slice::msgpack::v0 *table_slice_as_msgpack_v0() const {
    return table_slice_type() == vast::fbs::table_slice::TableSlice::msgpack_v0 ? static_cast<const vast::fbs::table_slice::msgpack::v0 *>(table_slice()) : nullptr;
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyField<uint8_t>(verifier, VT_TABLE_SLICE_TYPE) &&
           VerifyOffset(verifier, VT_TABLE_SLICE) &&
           VerifyTableSlice(verifier, table_slice(), table_slice_type()) &&
           verifier.EndTable();
  }
};

template<> inline const vast::fbs::table_slice::arrow::v0 *TableSlice::table_slice_as<vast::fbs::table_slice::arrow::v0>() const {
  return table_slice_as_arrow_v0();
}

template<> inline const vast::fbs::table_slice::msgpack::v0 *TableSlice::table_slice_as<vast::fbs::table_slice::msgpack::v0>() const {
  return table_slice_as_msgpack_v0();
}

struct TableSliceBuilder {
  typedef TableSlice Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_table_slice_type(vast::fbs::table_slice::TableSlice table_slice_type) {
    fbb_.AddElement<uint8_t>(TableSlice::VT_TABLE_SLICE_TYPE, static_cast<uint8_t>(table_slice_type), 0);
  }
  void add_table_slice(flatbuffers::Offset<void> table_slice) {
    fbb_.AddOffset(TableSlice::VT_TABLE_SLICE, table_slice);
  }
  explicit TableSliceBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  flatbuffers::Offset<TableSlice> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<TableSlice>(end);
    return o;
  }
};

inline flatbuffers::Offset<TableSlice> CreateTableSlice(
    flatbuffers::FlatBufferBuilder &_fbb,
    vast::fbs::table_slice::TableSlice table_slice_type = vast::fbs::table_slice::TableSlice::NONE,
    flatbuffers::Offset<void> table_slice = 0) {
  TableSliceBuilder builder_(_fbb);
  builder_.add_table_slice(table_slice);
  builder_.add_table_slice_type(table_slice_type);
  return builder_.Finish();
}

/// A vector of bytes that wraps a table slice.
/// The extra wrapping makes it possible to append existing table slices as
/// blobs to a segment builder. For example, this happens when the archive
/// receives a stream of table slices. Without the wrapping, we'd have to go
/// through a new table slice builder for every slice.
struct FlatTableSlice FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef FlatTableSliceBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "vast.fbs.FlatTableSlice";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_DATA = 4
  };
  const flatbuffers::Vector<uint8_t> *data() const {
    return GetPointer<const flatbuffers::Vector<uint8_t> *>(VT_DATA);
  }
  const vast::fbs::TableSlice *data_nested_root() const {
    return flatbuffers::GetRoot<vast::fbs::TableSlice>(data()->Data());
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_DATA) &&
           verifier.VerifyVector(data()) &&
           verifier.EndTable();
  }
};

struct FlatTableSliceBuilder {
  typedef FlatTableSlice Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_data(flatbuffers::Offset<flatbuffers::Vector<uint8_t>> data) {
    fbb_.AddOffset(FlatTableSlice::VT_DATA, data);
  }
  explicit FlatTableSliceBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  flatbuffers::Offset<FlatTableSlice> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<FlatTableSlice>(end);
    return o;
  }
};

inline flatbuffers::Offset<FlatTableSlice> CreateFlatTableSlice(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<flatbuffers::Vector<uint8_t>> data = 0) {
  FlatTableSliceBuilder builder_(_fbb);
  builder_.add_data(data);
  return builder_.Finish();
}

inline flatbuffers::Offset<FlatTableSlice> CreateFlatTableSliceDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    const std::vector<uint8_t> *data = nullptr) {
  auto data__ = data ? _fbb.CreateVector<uint8_t>(*data) : 0;
  return vast::fbs::CreateFlatTableSlice(
      _fbb,
      data__);
}

namespace table_slice {
namespace arrow {

}  // namespace arrow

namespace msgpack {

}  // namespace msgpack
}  // namespace table_slice

namespace table_slice {

inline bool VerifyTableSlice(flatbuffers::Verifier &verifier, const void *obj, TableSlice type) {
  switch (type) {
    case TableSlice::NONE: {
      return true;
    }
    case TableSlice::arrow_v0: {
      auto ptr = reinterpret_cast<const vast::fbs::table_slice::arrow::v0 *>(obj);
      return verifier.VerifyTable(ptr);
    }
    case TableSlice::msgpack_v0: {
      auto ptr = reinterpret_cast<const vast::fbs::table_slice::msgpack::v0 *>(obj);
      return verifier.VerifyTable(ptr);
    }
    default: return true;
  }
}

inline bool VerifyTableSliceVector(flatbuffers::Verifier &verifier, const flatbuffers::Vector<flatbuffers::Offset<void>> *values, const flatbuffers::Vector<uint8_t> *types) {
  if (!values || !types) return !values && !types;
  if (values->size() != types->size()) return false;
  for (flatbuffers::uoffset_t i = 0; i < values->size(); ++i) {
    if (!VerifyTableSlice(
        verifier,  values->Get(i), types->GetEnum<TableSlice>(i))) {
      return false;
    }
  }
  return true;
}

}  // namespace table_slice

inline const vast::fbs::TableSlice *GetTableSlice(const void *buf) {
  return flatbuffers::GetRoot<vast::fbs::TableSlice>(buf);
}

inline const vast::fbs::TableSlice *GetSizePrefixedTableSlice(const void *buf) {
  return flatbuffers::GetSizePrefixedRoot<vast::fbs::TableSlice>(buf);
}

inline bool VerifyTableSliceBuffer(
    flatbuffers::Verifier &verifier) {
  return verifier.VerifyBuffer<vast::fbs::TableSlice>(nullptr);
}

inline bool VerifySizePrefixedTableSliceBuffer(
    flatbuffers::Verifier &verifier) {
  return verifier.VerifySizePrefixedBuffer<vast::fbs::TableSlice>(nullptr);
}

inline void FinishTableSliceBuffer(
    flatbuffers::FlatBufferBuilder &fbb,
    flatbuffers::Offset<vast::fbs::TableSlice> root) {
  fbb.Finish(root);
}

inline void FinishSizePrefixedTableSliceBuffer(
    flatbuffers::FlatBufferBuilder &fbb,
    flatbuffers::Offset<vast::fbs::TableSlice> root) {
  fbb.FinishSizePrefixed(root);
}

}  // namespace fbs
}  // namespace vast

#endif  // FLATBUFFERS_GENERATED_TABLESLICE_VAST_FBS_H_
