
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was VASTConfig.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../" ABSOLUTE)

# Use original install prefix when loaded through a "/usr move"
# cross-prefix symbolic link such as /lib -> /usr/lib.
get_filename_component(_realCurr "${CMAKE_CURRENT_LIST_DIR}" REALPATH)
get_filename_component(_realOrig "/usr/lib/s390x-linux-gnu/cmake/vast" REALPATH)
if(_realCurr STREQUAL _realOrig)
  set(PACKAGE_PREFIX_DIR "/usr")
endif()
unset(_realOrig)
unset(_realCurr)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

include(CMakeFindDependencyMacro)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_dependency(Threads)

if (DEFINED CMAKE_MODULE_PATH)
  set(_CMAKE_MODULE_PATH_OLD ${CMAKE_MODULE_PATH})
endif ()
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")

set(VAST_ENABLE_ASSERTIONS ON)
set(VAST_ENABLE_ARROW OFF)
set(VAST_ENABLE_OPENSSL ON)
set(VAST_ENABLE_RELOCATABLE_INSTALLATIONS
  OFF)
set(VAST_ENABLE_UNIT_TESTS OFF)
set(VAST_CMAKE_BUILD_TYPE RelWithDebInfo)

include(VASTMacDependencyPaths)
include(VASTRegisterPlugin)


find_package(jemalloc REQUIRED)
find_package(tsl-robin-map 0.6.2 REQUIRED)
find_package(Flatbuffers REQUIRED CONFIG)
find_package(CAF COMPONENTS openssl REQUIRED)
find_package(CAF COMPONENTS core io test REQUIRED)
find_package(fmt 5.2.1 REQUIRED)
find_package(spdlog 1.5.0 REQUIRED)
find_package(simdjson REQUIRED CONFIGS "simdjson-config.cmake" "simdjson-targets.cmake")

if (DEFINED _CMAKE_MODULE_PATH_OLD)
  set(CMAKE_MODULE_PATH ${_CMAKE_MODULE_PATH_OLD})
  unset(_CMAKE_MODULE_PATH_OLD)
else ()
  unset(CMAKE_MODULE_PATH)
endif ()


include("${CMAKE_CURRENT_LIST_DIR}/VASTTargets.cmake")
